VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "GoogleMapsSigner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const S_OK As Long = 0
Private Const INTERNET_MAX_PATH_LENGTH As Long = 2048
Private Const INTERNET_MAX_SCHEME_LENGTH As Long = 32 'Longest protocol name length.
Private Const INTERNET_MAX_URL_LENGTH As Long = INTERNET_MAX_SCHEME_LENGTH _
                                              + INTERNET_MAX_PATH_LENGTH _
                                              + 3 'Len("://")

Private Enum tagPARSEACTION
    PARSE_CANONICALIZE = 1
    PARSE_FRIENDLY
    PARSE_SECURITY_URL
    PARSE_ROOTDOCUMENT
    PARSE_DOCUMENT
    PARSE_ANCHOR
    PARSE_ENCODE
    PARSE_DECODE
    PARSE_PATH_FROM_URL
    PARSE_URL_FROM_PATH
    PARSE_MIME
    PARSE_SERVER
    PARSE_SCHEMA
    PARSE_SITE
    PARSE_DOMAIN
    PARSE_LOCATION
    PARSE_SECURITY_DOMAIN
    PARSE_ESCAPE
    PARSE_UNESCAPE
End Enum

Private Declare Function CoInternetParseUrl Lib "urlmon" ( _
    ByVal pwzUrl As Long, _
    ByVal ParseAction As tagPARSEACTION, _
    ByVal dwFlags As Long, _
    ByVal pszResult As Long, _
    ByVal cchResult As Long, _
    ByRef cchResultOut As Long, _
    ByVal dwReserved As Long) As Long

Private HS1 As HS1

Public Function Sign(ByVal Url As String, ByVal PKeyMB64 As String) As String
    Dim Buffer As String
    Dim Ret As Long
    Dim cchResultOut As Long
    Dim PortionToSign As String
    Dim PKey() As Byte

    Buffer = Space$(INTERNET_MAX_URL_LENGTH)
    Ret = CoInternetParseUrl(StrPtr(Url), _
                             PARSE_ROOTDOCUMENT, _
                             0, _
                             StrPtr(Buffer), _
                             INTERNET_MAX_URL_LENGTH + 1, _
                             cchResultOut, _
                             0)
    If Ret <> S_OK Then
        Err.Raise 5, TypeName(Me), "Bad URL, CoInternetParseUrl returned " & CStr(Ret)
    End If
    'cchResultOut value is completely unreliable!
    PortionToSign = Mid$(Url, InStr(Buffer, vbNullChar))
    
    With HS1
        PKey = .Decode(Replace$(Replace$(PKeyMB64, "_", "/"), "-", "+"), edfBase64)
        .InitHmac PKey
        Sign = Url _
             & "&signature=" _
             & Replace$(Replace$(.Encode(.HmacSha1(.ToUTF8(PortionToSign)), edfBase64), _
                                 "/", _
                                 "_"), _
                        "+", _
                        "-")
    End With
End Function

Private Sub Class_Initialize()
    Set HS1 = New HS1
End Sub
